/*
    Copyright (C) 2013 Nicola L.C. Talbot
    www.dickimaw-books.com

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/
package com.dickimawbooks.makejmlrbookgui;

import java.awt.Cursor;

public class ProcessThread extends Thread
{
   public ProcessThread(MakeJmlrBookGUI application, BookRoot root)
   {
      this(application, root, false, false, true);
   }

   public ProcessThread(MakeJmlrBookGUI application, BookRoot root,
      boolean clearImportAux, boolean printVersion, boolean dorun)
   {
      super();

      app = application;
      this.bookRoot = root;
      this.clearImportAux = clearImportAux;
      this.printVersion = printVersion;
      this.dorun = dorun;
   }

   public void run()
   {
      app.debug("running process");
      app.setWaitCursor();
      app.debug("disable tools");
      app.disableTools();

      try
      {
         app.debug("processing");
         bookRoot.getBook().processBook(clearImportAux, printVersion, dorun);
      }
      catch (Exception e)
      {
         app.error(e);
      }

      app.workerThreadFinished(this);
      app.enableTools();
      app.bookLoaded();
      app.setInfo(app.getLabel("message.done"));
      app.setDefaultCursor();
   }

   private BookRoot bookRoot;
   private MakeJmlrBookGUI app;
   private boolean clearImportAux, printVersion, dorun;
} 
